#include <stdio.h>
#include <sys/types.h> 
#include <sys/socket.h> 
#include <sys/poll.h> 
#include <netinet/in.h> 


#define SIZE 2048 
char rbuf[SIZE];

#include "wfxa.h"
#include "apiwf.h"
#include "monlib.h"
#include "monlibwf.h"



main (int argc, char *argv[])
{
int sockfd, client_sockfd, xsockfd, client_xsockfd; 
struct sockaddr_in serv_addr, client_addr, xserv_addr, xclient_addr; 
struct pollfd pfd, xpfd;
int len, nread, ret;
WFXAframe *wfxa;
APIwiorecv *wior;
WFXArmtcmd *rcmd;
WFXArmtrsp *rresp;

    if(argc!=2){
      fprintf(stderr,"usage: %s port#\n",argv[0]);
      exit (-1);
    }
/* createendpoint */ 

	if ((sockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror(NULL); 
		exit(2); 
	} 
	if ((xsockfd = socket(AF_INET, SOCK_DGRAM, 0)) < 0) {
		perror(NULL); 
		exit(2); 
	} 
/* bind address */ 
	serv_addr.sin_family =AF_INET; 
	serv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	serv_addr.sin_port = htons(atoi(argv[1])); 
	if (bind(sockfd, (struct sockaddr *) &serv_addr,sizeof(serv_addr)) < 0) { 
		perror(NULL); 
		exit(3); 
	} 
	xserv_addr.sin_family =AF_INET; 
	xserv_addr.sin_addr.s_addr = htonl(INADDR_ANY);
	xserv_addr.sin_port = htons(0xBEE); 
	if (bind(xsockfd, (struct sockaddr *) &xserv_addr,sizeof(xserv_addr)) < 0) { 
		perror(NULL); 
		exit(3); 
	} 

  pfd.fd=sockfd;
  pfd.events=POLLIN;
  xpfd.fd=xsockfd;
  xpfd.events=POLLIN;

  while(1){
    if(poll(&pfd,1,0)){
	if(pfd.revents&POLLIN){
	  len = sizeof(client_addr); 
	  nread = recvfrom(sockfd, rbuf, SIZE, 0, (struct sockaddr *) &client_addr, &len); 
	  printf("Got msg from %s port %d (0x%04X)\n",inet_ntoa(client_addr.sin_addr.s_addr),ntohs(client_addr.sin_port),ntohs(client_addr.sin_port));
	  printf("RX: ");
	  prdata((unsigned char *)rbuf,nread,PRDATA_ASCII);
	  printf("\n\n");
	}
    }
    if(poll(&xpfd,1,0)){
	if(xpfd.revents&POLLIN){
	  len = sizeof(client_addr); 
	  nread = recvfrom(xsockfd, rbuf, SIZE, 0, (struct sockaddr *) &xclient_addr, &len); 
	  printf("Got msg from %s port 0x%03X\n",inet_ntoa(xclient_addr.sin_addr.s_addr),ntohs(xclient_addr.sin_port));
	  printf("RX: ");
	  prdata((unsigned char *)rbuf,nread,PRDATA_ASCII);
	  printf("\n");
	  wfxa=(WFXAframe *)rbuf;
	  switch(wfxa->id){
	  case WFXA_ACK:
		printf("ACK\n");
		break;
	  case WFXA_RMTRSP:
		rresp=(WFXArmtrsp *)wfxa->data;
		printf("Remote Command Response frame: ID: %02X\n",rresp->frameid);
		printf("STS: %s (%02X) DATA: ",prrst(rresp->status),rresp->status);
		prdata(&rresp->data,nread-7,0);
		printf("\n");
		break;
	  case WFXA_WIORECV:
		wior=(APIwiorecv *)wfxa->data;
		printf("I/O Data Receive,");
		prwiodata(wior);
		break;	  	
	  default:
		printf("*** UNKNOWN FRAME\n");
	  }
	  printf("\n");
	}
    }	  
  }
}



